#include <algorithm>
#include <string>
#include <vector>

struct Value {
	int node;
};

template<typename T>
struct NodeComparator {
	bool operator()(const T& a, const T& b) {
		return a < b;
	}
};

struct List : public std::vector<Value> {
	using ValueType = Value;
};

struct DumpContext {};

namespace JSC {
namespace DFG {
template<typename T>
std::string nodeValuePairListDump(const T& nodeValuePairList, DumpContext* context = 0)
{
    using V = typename T::ValueType;
    T sortedList = nodeValuePairList;
    std::sort(sortedList.begin(), sortedList.end(), [](const V& a, const V& b) {
        return NodeComparator<int>()(a.node, b.node);
    });
	return "";
}
}
}

int main(int argc, char** argv)
{
	List l;
	l.push_back(Value{.node = 2});
	l.push_back(Value{.node = 1});
	JSC::DFG::nodeValuePairListDump<List>(l);
	return 0;
}
